SystemOrganization addCategory: #'Zinc-SSO-Demo'!

ZnDefaultServerDelegate subclass: #ZnSSOServerDelegate
	instanceVariableNames: 'facebookData googleData microsoftData twitterData dropboxData googleOpenIDService yahooOpenIDService'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-SSO-Demo'!

!ZnSSOServerDelegate commentStamp: '<historical>' prior: 0!
I am ZnSSOServerDelegate, an example/test using SSO.

(ZnServer startOn: 8100)
	delegate: (ZnSSOServerDelegate new
		facebookData: (ZnOAuth2ConsumerData 
			key: '538399976180189'
			secret: '***************'
			redirectUrl: 'http://localhost:8100/sso-facebook-callback');
		googleData: (ZnOAuth2ConsumerData 
			key: '81499955779.apps.googleusercontent.com'
			secret: '***************'
			redirectUrl: 'http://localhost:8100/sso-google-callback');
		twitterData: (ZnOAuth1ConsumerData newForTwitterAuthentication 
			consumer: '5PAXu9CygKPD0aKwjnGdOA' ;
			consumerSecret: '*********');
		yourself);
	yourself.
!

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/23/2013 20:14'!
dropboxData
	^ dropboxData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/23/2013 20:14'!
dropboxData: anObject
	dropboxData := anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/23/2013 20:17'!
dropboxOAuth1Service

	^ ZnOAuth1Service new
		providerAccount: self dropboxData ;
		yourself! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'SvenVanCaekenberghe 1/23/2013 20:14'!
dropboxSessionFor: aRequest ifAbsent: aBlock

	^ aRequest session attributeAt: 'dropbox-session' ifAbsent: aBlock! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'SvenVanCaekenberghe 1/23/2013 20:15'!
dropboxSessionFor: aRequest put: anObject

	^ aRequest session attributeAt: 'dropbox-session' put: anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
facebookData
	^ facebookData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
facebookData: anObject
	facebookData := anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'SvenVanCaekenberghe 12/20/2012 09:50'!
facebookSessionFor: aRequest
	^ aRequest session 
		attributeAt: 'facebook-session' 
		ifAbsentPut: [ ZnOAuth2Session facebook: self facebookData ]! !

!ZnSSOServerDelegate methodsFor: 'private' stamp: 'JanVanDeSandt 12/7/2012 11:14'!
generateInvalidCallbackRequest

	| html entity |

	html := String streamContents: [ :stream |
		stream
			nextPutAll: '<h3>Not a valid callback request</h3>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
googleData
	^ googleData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 10/7/2012 13:32'!
googleData: anObject
	googleData := anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 1/5/2013 19:40'!
googleOpenIDService

	^ googleOpenIDService ifNil: [ googleOpenIDService := ZnOpenIDProvider newGoogleProvider createSession ]! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'SvenVanCaekenberghe 12/20/2012 09:49'!
googleSessionFor: aRequest
	^ aRequest session 
		attributeAt: 'google-session' 
		ifAbsentPut: [ ZnOAuth2Session google: self googleData ]! !

!ZnSSOServerDelegate methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/22/2012 19:01'!
htmlPageTitled: title do: block
	^ String streamContents: [ :stream |
		stream 
			<< '<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>';
			<< title;
			<< '</title>
<style type="text/css">
body {
  color: black;
  background: white;
  width: 900px;
  font-family: Verdana, Arial, Helvetica, sans-serif;
  font-size: 13px;
}
p {
  width: 600px;
  padding: 0 20px 10px 20px;
} 
ul,ol {
  width: 600px;
  padding: 0 5px 5px 30px;
} 
#logo {
  color: orange;
  font-family: Helvetica, sans-serif;
  font-weight: bold;
  font-size: 100px;
}
</style>
</head>
<body>
<div id="logo">Zn</div>
<h1>'; 
			<< title; 
			<<'</h1>'. 
		block value: stream. 
		stream << '</body></html>' ]! !

!ZnSSOServerDelegate methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/23/2013 20:16'!
initialize

	super initialize.
	
	self prefixMap
		at: 'sso-demo' put: #ssoDemo: ;
		at: 'sso-reset' put: #ssoReset: ;
		at: 'sso-google' put: #ssoGoogle: ;
		at: 'sso-google-callback' put: #ssoGoogleCallback: ;
		at: 'sso-google-data' put: #ssoGoogleData: ;
		at: 'sso-facebook' put: #ssoFacebook: ;
		at: 'sso-facebook-callback' put: #ssoFacebookCallback: ;
		at: 'sso-facebook-data' put: #ssoFacebookData: ;
		at: 'sso-microsoft' put: #ssoMicrosoft: ;
		at: 'sso-microsoft-callback' put: #ssoMicrosoftCallback: ;
		at: 'sso-microsoft-data' put: #ssoMicrosoftData: ;
		at: 'sso-twitter' put: #ssoTwitter: ;
		at: 'sso-twitter-callback' put: #ssoTwitterCallback: ;
		at: 'sso-twitter-data' put: #ssoTwitterData: ;
		at: 'sso-dropbox' put: #ssoDropbox: ;
		at: 'sso-dropbox-callback' put: #ssoDropboxCallback: ;
		at: 'sso-dropbox-data' put: #ssoDropboxData: ;
		at: 'sso-openid' put: #ssoOpenID: ;
		at: 'sso-openid-callback' put: #ssoOpenIDCallback: 

! !

!ZnSSOServerDelegate methodsFor: 'testing' stamp: 'JanVanDeSandt 12/7/2012 11:10'!
isOAuth2Callback: aRequest

	^aRequest uri queryKeys includes: 'code'! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 12/20/2012 23:21'!
microsoftData
	^ microsoftData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 12/20/2012 23:21'!
microsoftData: anObject
	microsoftData := anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'SvenVanCaekenberghe 12/20/2012 23:34'!
microsoftSessionFor: aRequest
	^ aRequest session 
		attributeAt: 'microsoft-session' 
		ifAbsentPut: [ ZnOAuth2Session microsoft: self microsoftData ]! !

!ZnSSOServerDelegate methodsFor: 'private' stamp: 'JanVanDeSandt 1/5/2013 19:38'!
openIdServiceFor: aProviderName

	aProviderName = 'Google'
		ifTrue: [ ^ self googleOpenIDService ].
		
	aProviderName = 'Yahoo'
		ifTrue: [ ^ self yahooOpenIDService ].
		
	self error: 'Unknown OpenID Provider'! !

!ZnSSOServerDelegate methodsFor: 'private' stamp: 'JanVanDeSandt 10/7/2012 14:38'!
printDictionary: aDictionary asHtmlOn: aStream

	aStream
		nextPutAll: '<ul>'.
	aDictionary keysAndValuesDo: [ :key :value |
		aStream
			nextPutAll: '<li>' ;
			nextPutAll: key.
		value isDictionary
			ifTrue: [ self printDictionary: value asHtmlOn: aStream ]
			ifFalse: [
				aStream
					nextPutAll: ' --> ' ;
					nextPutAll: value asString ].
		aStream nextPutAll: '</li>' ].
	aStream nextPutAll: '</ul>'! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'JanVanDeSandt 12/24/2012 11:30'!
resetSessions: request
	#(#google #microsoft #facebook #twitter) do: [ :each | 
			request session removeAttribute: each , '-session' ]! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 1/5/2013 19:35'!
ssoDemo: request
	| html session service token |
	html := self
		htmlPageTitled: 'Zinc SSO Demo'
		do: [ :stream | 
			stream << '<h2>OAuth2 Providers</h2>'.
			#(#Google #Facebook )
				do: [ :each |
					session := self perform: (each asLowercase, 'SessionFor:') asSymbol with: request.
					stream
						<< '<a href="';
						<< session authenticationUrl asString;
						<< '" title="Login with ';
						<< each;
						<< '">';
						<< each;
						<< '</a>' ]
				separatedBy: [ stream << ' | ' ].
			stream << '<h2>OAuth1 Providers</h2>'.
			service := self twitterOAuth1Service.
			token := service getRequestTokenFor: request server url / 'sso-twitter-callback'.
			self twitterSessionFor: request put: token.
			stream
				<< '<a href="';
				<< (service loginUrlFor: token) asString;
				<< '" title="Login with ';
				<< #Twitter;
				<< '">';
				<< #Twitter;
				<< '</a>'.
			stream << '<h2>OpenID Providers</h2>'.
			#( Google Yahoo ) 
				do: [ :each |
					stream
						<< '<a href=''sso-openid?provider=' ;
						<< each ;
						<< ''' title=''Login with ' ;
						<< each ;
						<< '''>' ;
						<< each ;
						<< '</a>' ]
				separatedBy: [ stream << ' | ' ].
			stream << '<h4>May the Source be with you!!</h4>' ].
	^ ZnResponse ok: (ZnEntity html: html)! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 1/26/2013 13:28'!
ssoDropbox: request

	| oauthService requestToken html entity |

	oauthService := self dropboxOAuth1Service.
	
	requestToken := oauthService getRequestToken.
	self dropboxSessionFor: request put: requestToken.
	
	html := self htmlPageTitled: 'Zinc SSO Dropbox Login' do: [ :stream |
		stream
			<< '<h3>Dropbox SSO</h3>' ;
			<< '<a href="' ;
			<< (oauthService loginUrlFor: requestToken callbackUrl: request server url / 'sso-dropbox-callback') asString ;
			<< '">Login with Dropbox</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 1/26/2013 14:15'!
ssoDropboxCallback: request

	| requestToken oauthToken accessToken |

	requestToken := self dropboxSessionFor: request 
		ifAbsent:  [ ^ self generateInvalidCallbackRequest ].

	oauthToken := request uri queryAt: 'oauth_token' ifAbsent: [ nil ].
	
	(oauthToken notNil and: [ oauthToken ~= requestToken value ])
		ifTrue: [ ^ self generateInvalidCallbackRequest ].
	
	accessToken := self dropboxOAuth1Service getAccessToken: requestToken.
	self dropboxSessionFor: request put: accessToken. 

	^ ZnResponse redirect: 'sso-dropbox-data'! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 1/27/2013 13:05'!
ssoDropboxData: request

	|  accessToken accountInfo rootInfo html entity |
	
	accessToken := self dropboxSessionFor: request
		ifAbsent: [ ^ self generateInvalidCallbackRequest ].
		
	accountInfo := ZnOAuth1DropboxUserAccess new
		oauth1Service: self dropboxOAuth1Service ;
		accessToken: accessToken ;
		getAccountInfo.

	rootInfo := ZnOAuth1DropboxUserAccess new
		oauth1Service: self dropboxOAuth1Service ;
		accessToken: accessToken ;
		getRootInfo.
	
	html := self htmlPageTitled: 'Zinc SSO Dropbox Account Info' do: [ :stream | 
		stream << '<h3>Dropbox Account Info</h3>'.
		self printDictionary: accountInfo asHtmlOn: stream.
		stream << '<h3>Dropbox Root Info</h3>'.
		self printDictionary: rootInfo asHtmlOn: stream.
		stream << '<a href="sso-reset">Reset</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/22/2012 18:54'!
ssoFacebook: request

	| facebookSession html entity |

	facebookSession := self facebookSessionFor: request.
		
	html := self htmlPageTitled: 'Zinc SSO Facebook Login' do:  [ :stream |
		stream
			<< '<h3>Facebook SSO</h3>' ;
			<< '<a href="' ;
			<< facebookSession authenticationUrl asString ;
			<< '">Login with Facebook</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/23/2012 19:26'!
ssoFacebookCallback: request

	| facebookSession |
	
	(self isOAuth2Callback: request)
		ifFalse: [ ^ self generateInvalidCallbackRequest ].
	
	facebookSession := self facebookSessionFor: request.
	facebookSession handleAuthenticationCallback: request uri query.
	
	^ ZnResponse redirect: 'sso-facebook-data'! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/23/2012 19:24'!
ssoFacebookData: request

	| facebookSession userData html entity |
	
	facebookSession := self facebookSessionFor: request.
	userData := facebookSession getUserData.

	html := self htmlPageTitled: 'Zinc SSO Facebook UserData' do: [ :stream | 
		stream << '<h3>Facebook UserData</h3>'.
		self printDictionary: userData asHtmlOn: stream.
		stream << '<a href="sso-reset">Reset</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/22/2012 18:57'!
ssoGoogle: request

	| googleSession html entity |
	
	googleSession := self googleSessionFor: request.
		
	html := self htmlPageTitled: 'Zinc SSO Google Login' do: [ :stream |
		stream
			<< '<h3>Google SSO</h3>' ;
			<< '<a href="' ;
			<< googleSession authenticationUrl asString ;
			<< '">Login with Google</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/23/2012 19:28'!
ssoGoogleCallback: request

	| googleSession |
	
	(self isOAuth2Callback: request)
		ifFalse: [ ^ self generateInvalidCallbackRequest ].

	googleSession := self googleSessionFor: request.
	googleSession handleAuthenticationCallback: request uri query.

	^ ZnResponse redirect: 'sso-google-data'! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/23/2012 19:27'!
ssoGoogleData: request

	| googleSession userData html entity |
	
	googleSession := self googleSessionFor: request.
	userData := googleSession getUserData.

	html := self htmlPageTitled: 'Zinc SSO Google UserData' do: [ :stream | 
		stream << '<h3>Google UserData</h3>'.
		self printDictionary: userData asHtmlOn: stream.
		stream << '<a href="sso-reset">Reset</a>'  ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/22/2012 18:58'!
ssoMicrosoft: request

	| microsoftSession html entity |

	microsoftSession := self microsoftSessionFor: request.
		
	html := self htmlPageTitled: 'Zinc SSO Microsoft Login' do: [ :stream |
		stream
			<< '<h3>Microsoft SSO</h3>' ;
			<< '<a href="' ;
			<< microsoftSession authenticationUrl asString ;
			<< '">Login with Microsoft</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/23/2012 19:28'!
ssoMicrosoftCallback: request

	| microsoftSession |
	
	(self isOAuth2Callback: request)
		ifFalse: [ ^ self generateInvalidCallbackRequest ].

	microsoftSession := self microsoftSessionFor: request.
	microsoftSession handleAuthenticationCallback: request uri query.

	^ ZnResponse redirect: 'sso-microsoft-data'! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/23/2012 19:27'!
ssoMicrosoftData: request

	| microsoftSession userData html entity |
	
	microsoftSession := self microsoftSessionFor: request.
	userData := microsoftSession getUserData.

	html := self htmlPageTitled: 'Zinc SSO Microsoft UserData' do: [ :stream | 
		stream << '<h3>Microsoft UserData</h3>'.
		self printDictionary: userData asHtmlOn: stream .
		stream << '<a href="sso-reset">Reset</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 1/5/2013 20:41'!
ssoOpenID: request

	| service serverUrl callbackUrl authUrl |
	
	service := self openIdServiceFor: (request url queryAt: 'provider' ifAbsent: [ nil ]).

	serverUrl  := request server url.
	callbackUrl := (serverUrl / 'sso-openid-callback')
		queryAt: 'provider' put: (request url queryAt: 'provider') ;
		yourself.
	
	authUrl := service getAuthenticationRequestUrl: callbackUrl do: [ :authRequest |
		authRequest realm: serverUrl asString.
		authRequest axRequestNamesAndEmail
		"self openIDoptionsForm updateAuthenticationRequest: authRequest "].
	
	^ ZnResponse redirect: authUrl! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 1/5/2013 21:09'!
ssoOpenIDCallback: request

	| service authResponse html |

	service := self openIdServiceFor: (request url queryAt: 'provider' ifAbsent: [ nil ]).
	
	authResponse := service getValidatedAuthenticationResponseFrom:	request url query.
		
	html := self htmlPageTitled: 'Zinc SSO OpenID result for ', service providerName do: [ :stream | 
		stream << '<h3>' ; << service providerName ; << ' result</h3>'.
		self printDictionary: authResponse properties asHtmlOn: stream .
		stream << '<a href="sso-reset">Reset</a>' ].

	^ ZnResponse ok: (ZnEntity html: html)! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 12/22/2012 19:19'!
ssoReset: request
	| target |
	self resetSessions: request.
	target := request uri queryAt: #target ifAbsent: [ 'sso-demo' ].
	^ ZnResponse redirect: target! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'SvenVanCaekenberghe 1/4/2013 13:54'!
ssoTwitter: request

	| oauthService requestToken html entity |

	oauthService := self twitterOAuth1Service.
	
	requestToken := oauthService getRequestTokenFor: request server url / 'sso-twitter-callback'.
	self twitterSessionFor: request put: requestToken.
	
	html := self htmlPageTitled: 'Zinc SSO Twitter Login' do: [ :stream |
		stream
			<< '<h3>Twitter SSO</h3>' ;
			<< '<a href="' ;
			<< (oauthService loginUrlFor: requestToken) asString ;
			<< '">Login with Twitter</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 12/24/2012 11:39'!
ssoTwitterCallback: request

	| requestToken oauthToken oauthVerifier accessToken |

	requestToken := self twitterSessionFor: request 
		ifAbsent:  [ ^ self generateInvalidCallbackRequest ].

	oauthToken := request uri queryAt: 'oauth_token'.
	oauthVerifier := request uri queryAt: 'oauth_verifier'.
	
	(oauthToken isNil or: [ oauthVerifier isNil])
		ifTrue: [ ^ self generateInvalidCallbackRequest ].
		
	oauthToken = requestToken value
		ifFalse: [ ^ self generateInvalidCallbackRequest ].
	
	accessToken := self twitterOAuth1Service getAccessToken: requestToken verifier: oauthVerifier.
	self twitterSessionFor: request put: accessToken. 

	^ ZnResponse redirect: 'sso-twitter-data'! !

!ZnSSOServerDelegate methodsFor: 'responses' stamp: 'JanVanDeSandt 12/27/2012 11:45'!
ssoTwitterData: request

	|  accessToken userData html entity |
	
	accessToken := self twitterSessionFor: request
		ifAbsent: [ ^ self generateInvalidCallbackRequest ].
		
	userData := ZnOAuth1TwitterUserAccess new
		oauth1Service: self twitterOAuth1Service ;
		accessToken: accessToken ;
		accountVerifyCredentials.
	
	html := self htmlPageTitled: 'Zinc SSO Twitter UserData' do: [ :stream | 
		stream << '<h3>Twitter UserData</h3>'.
		self printDictionary: userData asHtmlOn: stream .
		stream << '<a href="sso-reset">Reset</a>' ].

	entity := ZnEntity html: html. 
	^ ZnResponse ok: entity! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 12/24/2012 10:28'!
twitterData

	^ twitterData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 12/24/2012 10:55'!
twitterData: aConsumerData

	twitterData := aConsumerData! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 12/24/2012 10:58'!
twitterOAuth1Service

	^ ZnOAuth1Service new
		providerAccount: self twitterData ;
		yourself! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'JanVanDeSandt 12/24/2012 11:34'!
twitterSessionFor: aRequest ifAbsent: aBlock

	^ aRequest session attributeAt: 'twitter-session' ifAbsent: aBlock! !

!ZnSSOServerDelegate methodsFor: 'accessing-session' stamp: 'JanVanDeSandt 12/24/2012 11:42'!
twitterSessionFor: aRequest put: anObject

	^ aRequest session attributeAt: 'twitter-session' put: anObject! !

!ZnSSOServerDelegate methodsFor: 'accessing' stamp: 'JanVanDeSandt 1/5/2013 19:40'!
yahooOpenIDService

	^ yahooOpenIDService ifNil: [ yahooOpenIDService := ZnOpenIDProvider newYahooProvider createSession ]! !
